from .download import download_zip, download_file
from pathlib import Path
down_path = Path(__file__).parent
xz_url = "addons_file"+"/"+down_path.name+"/"
download_zip(xz_url + "assets.zip",down_path)
download_zip(xz_url + "icons.zip",down_path)


bl_info = {
    "name" : "WaterShader",
    "author" : "chuck cg", 
    "description" : "Water shader+Landscapes, easily create water scenes ",
    "blender" : (4, 1, 0),
    "version" : (1, 2, 2),
    "location" : "",
    "warning" : "",
    "doc_url": "", 
    "tracker_url": "", 
    "category" : "Material" 
}


import bpy
import bpy.utils.previews
import os
from .translation.translate import GetTranslationDict


addon_keymaps = {}
_icons = None
class SNA_PT_WATER_SHADER_A4317(bpy.types.Panel):
    bl_label = 'Water Shader'
    bl_idname = 'SNA_PT_WATER_SHADER_A4317'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'WaterShader'
    bl_order = 0
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not (False)

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        layout.template_icon(icon_value=_icons['cover.jpg'].icon_id, scale=9.586999893188477)
        row_3ABF1 = layout.row(heading='', align=True)
        row_3ABF1.alert = False
        row_3ABF1.enabled = True
        row_3ABF1.active = True
        row_3ABF1.use_property_split = False
        row_3ABF1.use_property_decorate = False
        row_3ABF1.scale_x = 1.4500000476837158
        row_3ABF1.scale_y = 2.6679999828338623
        row_3ABF1.alignment = 'Center'.upper()
        row_3ABF1.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        op = row_3ABF1.operator('sna.import_water_cube_47fd5', text='Add Water Cube', icon_value=478, emboss=True, depress=False)
        row_2B60A = layout.row(heading='', align=True)
        row_2B60A.alert = False
        row_2B60A.enabled = True
        row_2B60A.active = True
        row_2B60A.use_property_split = False
        row_2B60A.use_property_decorate = False
        row_2B60A.scale_x = 1.600000023841858
        row_2B60A.scale_y = 2.380000114440918
        row_2B60A.alignment = 'Center'.upper()
        row_2B60A.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        op = row_2B60A.operator('sna.terrainsimp_5305a', text='Add Terrains', icon_value=_icons['mt icon2.jpg'].icon_id, emboss=True, depress=False)
        row_44B44 = layout.row(heading='', align=False)
        row_44B44.alert = False
        row_44B44.enabled = True
        row_44B44.active = True
        row_44B44.use_property_split = False
        row_44B44.use_property_decorate = False
        row_44B44.scale_x = 1.9390000104904175
        row_44B44.scale_y = 2.244999885559082
        row_44B44.alignment = 'Center'.upper()
        row_44B44.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        op = row_44B44.operator('sna.canoes_c33a1', text='Assets', icon_value=287, emboss=True, depress=False)


class SNA_OT_Import_Water_Cube_47Fd5(bpy.types.Operator):
    bl_idname = "sna.import_water_cube_47fd5"
    bl_label = "Import Water Cube"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        before_data = list(bpy.data.objects)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'WaterShader4_1.blend') + r'\Object', filename='water_shader', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.objects)))
        appended_C68A7 = None if not new_data else new_data[0]
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Terrainsimp_5305A(bpy.types.Operator):
    bl_idname = "sna.terrainsimp_5305a"
    bl_label = "terrainsimp"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        bpy.ops.wm.append('INVOKE_DEFAULT', filepath=os.path.join(os.path.join(os.path.dirname(__file__), 'assets', 'terrains1.blend'),'Object'))
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Canoes_C33A1(bpy.types.Operator):
    bl_idname = "sna.canoes_c33a1"
    bl_label = "canoes"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        bpy.ops.wm.append('INVOKE_DEFAULT', filepath=os.path.join(os.path.join(os.path.dirname(__file__), 'assets', 'Ancient_canoes.blend'),'Object'))
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


def register():
    global _icons
    _icons = bpy.utils.previews.new()
    bpy.utils.register_class(SNA_PT_WATER_SHADER_A4317)
    if not 'cover.jpg' in _icons: _icons.load('cover.jpg', os.path.join(os.path.dirname(__file__), 'icons', 'cover.jpg'), "IMAGE")
    if not 'mt icon2.jpg' in _icons: _icons.load('mt icon2.jpg', os.path.join(os.path.dirname(__file__), 'icons', 'mt icon2.jpg'), "IMAGE")
    bpy.utils.register_class(SNA_OT_Import_Water_Cube_47Fd5)
    bpy.utils.register_class(SNA_OT_Terrainsimp_5305A)
    bpy.utils.register_class(SNA_OT_Canoes_C33A1)
    try:
        bpy.app.translations.register(__package__, GetTranslationDict())
    except:
        pass


def unregister():
    global _icons
    bpy.utils.previews.remove(_icons)
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    bpy.utils.unregister_class(SNA_PT_WATER_SHADER_A4317)
    bpy.utils.unregister_class(SNA_OT_Import_Water_Cube_47Fd5)
    bpy.utils.unregister_class(SNA_OT_Terrainsimp_5305A)
    bpy.utils.unregister_class(SNA_OT_Canoes_C33A1)
    try:
        bpy.app.translations.unregister(__package__)
    except:
        pass
